Index: /branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.Designer.cs
===================================================================
--- /branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.Designer.cs	(revision 15421)
+++ /branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.Designer.cs	(revision 15422)
@@ -36,6 +36,7 @@
       this.projectView = new HeuristicLab.Clients.Hive.Administrator.Views.ProjectView();
       this.permissionsTabPage = new System.Windows.Forms.TabPage();
-      this.savePermissionsButton = new System.Windows.Forms.Button();
-      this.permissionsView = new HeuristicLab.Clients.Access.Views.RefreshableLightweightUserView();
+      this.projectPermissionsView = new HeuristicLab.Clients.Hive.Administrator.Views.ProjectPermissionsView();
+      this.resourcesTabPage = new System.Windows.Forms.TabPage();
+      this.projectResourcesView = new HeuristicLab.Clients.Hive.Administrator.Views.ProjectResourcesView();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
       this.splitContainer.Panel1.SuspendLayout();
@@ -45,4 +46,5 @@
       this.detailsTabPage.SuspendLayout();
       this.permissionsTabPage.SuspendLayout();
+      this.resourcesTabPage.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -82,5 +84,5 @@
       // saveProjectButton
       // 
-      this.saveProjectButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
+      this.saveProjectButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
       this.saveProjectButton.Location = new System.Drawing.Point(93, 3);
       this.saveProjectButton.Name = "saveProjectButton";
@@ -143,4 +145,5 @@
       this.tabControl.Controls.Add(this.detailsTabPage);
       this.tabControl.Controls.Add(this.permissionsTabPage);
+      this.tabControl.Controls.Add(this.resourcesTabPage);
       this.tabControl.Location = new System.Drawing.Point(3, 3);
       this.tabControl.Name = "tabControl";
@@ -148,5 +151,4 @@
       this.tabControl.Size = new System.Drawing.Size(585, 541);
       this.tabControl.TabIndex = 0;
-      this.tabControl.SelectedIndexChanged += new System.EventHandler(this.tabControl_SelectedIndexChanged);
       // 
       // detailsTabPage
@@ -176,6 +178,5 @@
       // permissionsTabPage
       // 
-      this.permissionsTabPage.Controls.Add(this.savePermissionsButton);
-      this.permissionsTabPage.Controls.Add(this.permissionsView);
+      this.permissionsTabPage.Controls.Add(this.projectPermissionsView);
       this.permissionsTabPage.Location = new System.Drawing.Point(4, 22);
       this.permissionsTabPage.Name = "permissionsTabPage";
@@ -186,28 +187,36 @@
       this.permissionsTabPage.UseVisualStyleBackColor = true;
       // 
-      // savePermissionsButton
-      // 
-      this.savePermissionsButton.Enabled = false;
-      this.savePermissionsButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
-      this.savePermissionsButton.Location = new System.Drawing.Point(39, 9);
-      this.savePermissionsButton.Name = "savePermissionsButton";
-      this.savePermissionsButton.Size = new System.Drawing.Size(24, 24);
-      this.savePermissionsButton.TabIndex = 2;
-      this.savePermissionsButton.UseVisualStyleBackColor = true;
-      this.savePermissionsButton.Click += new System.EventHandler(this.savePermissionsButton_Click);
-      // 
-      // permissionsView
-      // 
-      this.permissionsView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.permissionsView.Caption = "RefreshableLightweightUser View";
-      this.permissionsView.Content = null;
-      this.permissionsView.FetchSelectedUsers = null;
-      this.permissionsView.Location = new System.Drawing.Point(6, 6);
-      this.permissionsView.Name = "permissionsView";
-      this.permissionsView.ReadOnly = false;
-      this.permissionsView.Size = new System.Drawing.Size(565, 503);
-      this.permissionsView.TabIndex = 0;
+      // projectPermissionsView
+      // 
+      this.projectPermissionsView.Caption = "ProjectView";
+      this.projectPermissionsView.Content = null;
+      this.projectPermissionsView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.projectPermissionsView.Location = new System.Drawing.Point(3, 3);
+      this.projectPermissionsView.Name = "projectPermissionsView";
+      this.projectPermissionsView.ReadOnly = false;
+      this.projectPermissionsView.Size = new System.Drawing.Size(571, 509);
+      this.projectPermissionsView.TabIndex = 0;
+      // 
+      // resourcesTabPage
+      // 
+      this.resourcesTabPage.Controls.Add(this.projectResourcesView);
+      this.resourcesTabPage.Location = new System.Drawing.Point(4, 22);
+      this.resourcesTabPage.Name = "resourcesTabPage";
+      this.resourcesTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.resourcesTabPage.Size = new System.Drawing.Size(577, 515);
+      this.resourcesTabPage.TabIndex = 2;
+      this.resourcesTabPage.Text = "Resources";
+      this.resourcesTabPage.UseVisualStyleBackColor = true;
+      // 
+      // projectResourcesView
+      // 
+      this.projectResourcesView.Caption = "ProjectView";
+      this.projectResourcesView.Content = null;
+      this.projectResourcesView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.projectResourcesView.Location = new System.Drawing.Point(3, 3);
+      this.projectResourcesView.Name = "projectResourcesView";
+      this.projectResourcesView.ReadOnly = false;
+      this.projectResourcesView.Size = new System.Drawing.Size(571, 509);
+      this.projectResourcesView.TabIndex = 0;
       // 
       // ProjectsView
@@ -226,4 +235,5 @@
       this.detailsTabPage.ResumeLayout(false);
       this.permissionsTabPage.ResumeLayout(false);
+      this.resourcesTabPage.ResumeLayout(false);
       this.ResumeLayout(false);
 
@@ -243,6 +253,7 @@
     private ProjectView projectView;
     private System.Windows.Forms.ImageList imageList;
-    private Access.Views.RefreshableLightweightUserView permissionsView;
-    private System.Windows.Forms.Button savePermissionsButton;
+    private System.Windows.Forms.TabPage resourcesTabPage;
+    private ProjectResourcesView projectResourcesView;
+    private ProjectPermissionsView projectPermissionsView;
   }
 }
Index: /branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.cs
===================================================================
--- /branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.cs	(revision 15421)
+++ /branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ProjectsView.cs	(revision 15422)
@@ -42,7 +42,4 @@
 
     private readonly object locker = new object();
-    private bool updatingProjects = false;
-    private bool removingProjects = false;
-    private bool savingProjects = false;
 
     public new IItemList<Project> Content {
@@ -89,10 +86,11 @@
         projectsTreeView.Nodes.Clear();
         projectView.Content = null;
-        permissionsView.Content = null;
-        permissionsView.FetchSelectedUsers = null;
+        projectPermissionsView.Content = null;
+        projectResourcesView.Content = null;
       } else {
         var top = BuildProjectTree(Content);
         projectView.Content = top;
-        permissionsView.Content = AccessClient.Instance;
+        projectPermissionsView.Content = top;
+        projectResourcesView.Content = top;
       }
     }
@@ -100,10 +98,12 @@
     protected override void SetEnabledStateOfControls() {
       base.SetEnabledStateOfControls();
-      bool enabled = Content != null;
+      bool enabled = Content != null && !ReadOnly;
+      refreshButton.Enabled = enabled;
       addButton.Enabled = enabled;
       removeButton.Enabled = enabled;
       saveProjectButton.Enabled = enabled;
-      savePermissionsButton.Enabled = enabled && permissionsView.Content != null && permissionsView.FetchSelectedUsers != null;
-      permissionsView.Enabled = enabled && permissionsView.Content != null && permissionsView.FetchSelectedUsers != null;
+      projectView.Enabled = enabled;
+      projectPermissionsView.Enabled = enabled;
+      projectResourcesView.Enabled = enabled;
     }
     #endregion
@@ -175,6 +175,6 @@
     private async void refreshButton_Click(object sender, EventArgs e) {
       lock (locker) {
-        if (updatingProjects) return;
-        updatingProjects = true;
+        if (!refreshButton.Enabled) return;
+        refreshButton.Enabled = false;
       }
 
@@ -183,5 +183,5 @@
         finallyCallback: () => {
           Content = HiveAdminClient.Instance.Projects;
-          updatingProjects = false;
+          refreshButton.Enabled = true;
         });
     }
@@ -197,6 +197,6 @@
     private async void removeButton_Click(object sender, EventArgs e) {
       lock (locker) {
-        if (removingProjects) return;
-        removingProjects = true;
+        if (!removeButton.Enabled) return;
+        removeButton.Enabled = false;
       }
 
@@ -223,5 +223,5 @@
             finallyCallback: () => {
               Content.Remove(project);
-              removingProjects = false;
+              removeButton.Enabled = true;
             });
         }
@@ -231,6 +231,6 @@
     private async void saveProjectButton_Click(object sender, EventArgs e) {
       lock (locker) {
-        if (savingProjects) return;
-        savingProjects = true;
+        if (!saveProjectButton.Enabled) return;
+        saveProjectButton.Enabled = false;
       }
 
@@ -241,8 +241,8 @@
             project.Store();
         },
-        finallyCallback: () => savingProjects = false);
-    }
-
-    private async void projectsTreeView_AfterSelect(object sender, TreeViewEventArgs e) {
+        finallyCallback: () => saveProjectButton.Enabled = true);
+    }
+
+    private void projectsTreeView_AfterSelect(object sender, TreeViewEventArgs e) {
       var selectedProject = (Project)e.Node.Tag;
 
@@ -251,4 +251,6 @@
 
       projectView.Content = selectedProject;
+      projectPermissionsView.Content = selectedProject;
+      projectResourcesView.Content = selectedProject;
 
       if (selectedProject != null)
@@ -258,17 +260,11 @@
         if (!tabControl.TabPages.Contains(permissionsTabPage))
           tabControl.TabPages.Add(permissionsTabPage);
-
-        permissionsView.FetchSelectedUsers = () =>
-          HiveServiceLocator.Instance.CallHiveService(s => s.GetProjectPermissions(selectedProject.Id))
-                                     .Select(x => x.GrantedUserId)
-                                     .ToList();
-
-        if (tabControl.SelectedIndex == 1 && permissionsView.Content != null && permissionsView.FetchSelectedUsers != null)
-          await SecurityExceptionUtil.TryAsyncAndReportSecurityExceptions(
-            action: () => UpdatePermissions());
+        if (!tabControl.TabPages.Contains(resourcesTabPage))
+          tabControl.TabPages.Add(resourcesTabPage);
       } else {
         if (tabControl.TabPages.Contains(permissionsTabPage))
           tabControl.TabPages.Remove(permissionsTabPage);
-        permissionsView.FetchSelectedUsers = null;
+        if (tabControl.TabPages.Contains(resourcesTabPage))
+          tabControl.TabPages.Remove(resourcesTabPage);
       }
     }
@@ -317,20 +313,4 @@
     private void projectsTreeView_QueryContinueDrag(object sender, QueryContinueDragEventArgs e) {
       e.Action = DragAction.Continue;
-    }
-
-    private async void tabControl_SelectedIndexChanged(object sender, EventArgs e) {
-      if (tabControl.SelectedIndex == 1 && permissionsView.Content != null && permissionsView.FetchSelectedUsers != null)
-        await SecurityExceptionUtil.TryAsyncAndReportSecurityExceptions(
-          action: () => UpdatePermissions());
-    }
-
-    private async void savePermissionsButton_Click(object sender, EventArgs e) {
-      var project = (Project)projectsTreeView.SelectedNode.Tag;
-
-      await SecurityExceptionUtil.TryAsyncAndReportSecurityExceptions(
-        action: () => HiveServiceLocator.Instance.CallHiveService(s => {
-          s.GrantProjectPermissions(project.Id, permissionsView.GetAddedUsers().Select(x => x.Id).ToList());
-          s.RevokeProjectPermissions(project.Id, permissionsView.GetDeletedUsers().Select(x => x.Id).ToList());
-        }));
     }
     #endregion
@@ -401,12 +381,4 @@
     }
 
-    private void UpdatePermissions() {
-      try {
-        permissionsView.ManualRefresh();
-      } catch (AnonymousUserException) {
-        ShowHiveInformationDialog();
-      }
-    }
-
     private bool IsAuthorized(Project project) {
       return project != null
Index: /branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourceView.Designer.cs
===================================================================
--- /branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourceView.Designer.cs	(revision 15422)
+++ /branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourceView.Designer.cs	(revision 15422)
@@ -0,0 +1,169 @@
+﻿namespace HeuristicLab.Clients.Hive.Administrator.Views {
+  partial class ResourceView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.idLabel = new System.Windows.Forms.Label();
+      this.idTextBox = new System.Windows.Forms.TextBox();
+      this.nameLabel = new System.Windows.Forms.Label();
+      this.nameTextBox = new System.Windows.Forms.TextBox();
+      this.descriptionLabel = new System.Windows.Forms.Label();
+      this.descriptionTextBox = new System.Windows.Forms.TextBox();
+      this.heartbeatIntervalLabel = new System.Windows.Forms.Label();
+      this.heartbeatIntervalNumericUpDown = new System.Windows.Forms.NumericUpDown();
+      this.publicLabel = new System.Windows.Forms.Label();
+      this.publicCheckBox = new System.Windows.Forms.CheckBox();
+      ((System.ComponentModel.ISupportInitialize)(this.heartbeatIntervalNumericUpDown)).BeginInit();
+      this.SuspendLayout();
+      // 
+      // idLabel
+      // 
+      this.idLabel.AutoSize = true;
+      this.idLabel.Location = new System.Drawing.Point(3, 11);
+      this.idLabel.Name = "idLabel";
+      this.idLabel.Size = new System.Drawing.Size(19, 13);
+      this.idLabel.TabIndex = 0;
+      this.idLabel.Text = "Id:";
+      // 
+      // idTextBox
+      // 
+      this.idTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.idTextBox.Location = new System.Drawing.Point(130, 8);
+      this.idTextBox.Name = "idTextBox";
+      this.idTextBox.ReadOnly = true;
+      this.idTextBox.Size = new System.Drawing.Size(397, 20);
+      this.idTextBox.TabIndex = 1;
+      // 
+      // nameLabel
+      // 
+      this.nameLabel.AutoSize = true;
+      this.nameLabel.Location = new System.Drawing.Point(3, 37);
+      this.nameLabel.Name = "nameLabel";
+      this.nameLabel.Size = new System.Drawing.Size(38, 13);
+      this.nameLabel.TabIndex = 2;
+      this.nameLabel.Text = "Name:";
+      // 
+      // nameTextBox
+      // 
+      this.nameTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.nameTextBox.Location = new System.Drawing.Point(130, 34);
+      this.nameTextBox.Name = "nameTextBox";
+      this.nameTextBox.Size = new System.Drawing.Size(397, 20);
+      this.nameTextBox.TabIndex = 3;
+      this.nameTextBox.TextChanged += new System.EventHandler(this.nameTextBox_TextChanged);
+      // 
+      // descriptionLabel
+      // 
+      this.descriptionLabel.AutoSize = true;
+      this.descriptionLabel.Location = new System.Drawing.Point(3, 63);
+      this.descriptionLabel.Name = "descriptionLabel";
+      this.descriptionLabel.Size = new System.Drawing.Size(63, 13);
+      this.descriptionLabel.TabIndex = 4;
+      this.descriptionLabel.Text = "Description:";
+      // 
+      // descriptionTextBox
+      // 
+      this.descriptionTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.descriptionTextBox.Location = new System.Drawing.Point(130, 60);
+      this.descriptionTextBox.Name = "descriptionTextBox";
+      this.descriptionTextBox.Size = new System.Drawing.Size(397, 20);
+      this.descriptionTextBox.TabIndex = 5;
+      this.descriptionTextBox.TextChanged += new System.EventHandler(this.descriptionTextBox_TextChanged);
+      // 
+      // heartbeatIntervalLabel
+      // 
+      this.heartbeatIntervalLabel.AutoSize = true;
+      this.heartbeatIntervalLabel.Location = new System.Drawing.Point(3, 89);
+      this.heartbeatIntervalLabel.Name = "heartbeatIntervalLabel";
+      this.heartbeatIntervalLabel.Size = new System.Drawing.Size(121, 13);
+      this.heartbeatIntervalLabel.TabIndex = 8;
+      this.heartbeatIntervalLabel.Text = "Heartbeat Interval [sec]:";
+      // 
+      // heartbeatIntervalNumericUpDown
+      // 
+      this.heartbeatIntervalNumericUpDown.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.heartbeatIntervalNumericUpDown.Location = new System.Drawing.Point(130, 86);
+      this.heartbeatIntervalNumericUpDown.Name = "heartbeatIntervalNumericUpDown";
+      this.heartbeatIntervalNumericUpDown.Size = new System.Drawing.Size(397, 20);
+      this.heartbeatIntervalNumericUpDown.TabIndex = 9;
+      this.heartbeatIntervalNumericUpDown.ValueChanged += new System.EventHandler(this.heartbeatIntervalNumericUpDown_ValueChanged);
+      // 
+      // publicLabel
+      // 
+      this.publicLabel.AutoSize = true;
+      this.publicLabel.Location = new System.Drawing.Point(3, 115);
+      this.publicLabel.Name = "publicLabel";
+      this.publicLabel.Size = new System.Drawing.Size(39, 13);
+      this.publicLabel.TabIndex = 12;
+      this.publicLabel.Text = "Public:";
+      // 
+      // publicCheckBox
+      // 
+      this.publicCheckBox.AutoSize = true;
+      this.publicCheckBox.Location = new System.Drawing.Point(130, 114);
+      this.publicCheckBox.Name = "publicCheckBox";
+      this.publicCheckBox.Size = new System.Drawing.Size(15, 14);
+      this.publicCheckBox.TabIndex = 13;
+      this.publicCheckBox.UseVisualStyleBackColor = true;
+      this.publicCheckBox.CheckedChanged += new System.EventHandler(this.publicCheckBox_CheckedChanged);
+      // 
+      // SlaveGroupView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.publicCheckBox);
+      this.Controls.Add(this.publicLabel);
+      this.Controls.Add(this.heartbeatIntervalNumericUpDown);
+      this.Controls.Add(this.heartbeatIntervalLabel);
+      this.Controls.Add(this.descriptionTextBox);
+      this.Controls.Add(this.descriptionLabel);
+      this.Controls.Add(this.nameTextBox);
+      this.Controls.Add(this.nameLabel);
+      this.Controls.Add(this.idTextBox);
+      this.Controls.Add(this.idLabel);
+      this.Name = "SlaveGroupView";
+      this.Size = new System.Drawing.Size(530, 350);
+      ((System.ComponentModel.ISupportInitialize)(this.heartbeatIntervalNumericUpDown)).EndInit();
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Label idLabel;
+    private System.Windows.Forms.Label nameLabel;
+    private System.Windows.Forms.Label descriptionLabel;
+    private System.Windows.Forms.Label heartbeatIntervalLabel;
+    private System.Windows.Forms.Label publicLabel;
+    protected System.Windows.Forms.TextBox nameTextBox;
+    protected System.Windows.Forms.TextBox idTextBox;
+    protected System.Windows.Forms.TextBox descriptionTextBox;
+    protected System.Windows.Forms.NumericUpDown heartbeatIntervalNumericUpDown;
+    protected System.Windows.Forms.CheckBox publicCheckBox;
+  }
+}
Index: /branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourceView.cs
===================================================================
--- /branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourceView.cs	(revision 15422)
+++ /branches/HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ResourceView.cs	(revision 15422)
@@ -0,0 +1,91 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Clients.Access;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Clients.Hive.Administrator.Views {
+  [View("Resource View")]
+  [Content(typeof(Resource), IsDefaultView = true)]
+  public partial class ResourceView : ItemView {
+    public new Resource Content {
+      get { return (Resource)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public ResourceView() {
+      InitializeComponent();
+    }
+
+    #region Overrides
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        idTextBox.Clear();
+        nameTextBox.Clear();
+        descriptionTextBox.Clear();
+        heartbeatIntervalNumericUpDown.Value = 0;
+        publicCheckBox.Checked = false;
+      } else {
+        idTextBox.Text = Content.Id.ToString();
+        nameTextBox.Text = Content.Name;
+        descriptionTextBox.Text = Content.Description;
+        heartbeatIntervalNumericUpDown.Value = Content.HbInterval;
+        publicCheckBox.Checked = Content.OwnerUserId == null;
+      }
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      bool enabled = Content != null;
+      nameTextBox.Enabled = enabled;
+      descriptionTextBox.Enabled = enabled;
+      heartbeatIntervalNumericUpDown.Enabled = enabled;
+      publicCheckBox.Enabled = enabled;
+    }
+    #endregion
+
+    #region Event Handlers
+    private void nameTextBox_TextChanged(object sender, EventArgs e) {
+      if (Content != null && Content.Name != nameTextBox.Text)
+        Content.Name = nameTextBox.Text;
+    }
+
+    private void descriptionTextBox_TextChanged(object sender, EventArgs e) {
+      if (Content != null && Content.Description != descriptionTextBox.Text)
+        Content.Description = descriptionTextBox.Text;
+    }
+
+    private void heartbeatIntervalNumericUpDown_ValueChanged(object sender, EventArgs e) {
+      if (Content != null && Content.HbInterval != (int)heartbeatIntervalNumericUpDown.Value)
+        Content.HbInterval = (int)heartbeatIntervalNumericUpDown.Value;
+    }
+
+    private void publicCheckBox_CheckedChanged(object sender, EventArgs e) {
+      var newOwnerUserId = publicCheckBox.Checked ? null : (Guid?)UserInformation.Instance.User.Id;
+      if (Content != null && Content.OwnerUserId != newOwnerUserId)
+        Content.OwnerUserId = newOwnerUserId;
+    }
+    #endregion
+  }
+}
